public class QueueTest {
  public static void main(String[] args) {
    QueueArrayBased Queue1 = new QueueArrayBased();
    QueueArrayBased Queue2 = new QueueArrayBased();
    QueueArrayBased Queue3 = new QueueArrayBased();
    
    Queue1.enqueue(new Integer(1));
    Queue1.enqueue(new Integer(2));
    Queue1.enqueue(new Integer(3));
    Queue1.enqueue(new Integer(5));    
    
    Queue2.enqueue(new Integer(1));
    Queue2.enqueue(new Integer(4));    
    Queue2.enqueue(new Integer(9));
    Queue2.enqueue(new Integer(12));
    
    // non-trivial case; both of them are not empty
    while (!Queue1.isEmpty() && !Queue2.isEmpty()) {
        int a = ((Integer)Queue1.peek()).intValue();
        int b = ((Integer)Queue2.peek()).intValue();
        if (a > b) {
            Queue3.enqueue(Queue2.dequeue());
        }
        else if (a < b) {
            Queue3.enqueue(Queue1.dequeue());
        }
        else {
            Queue3.enqueue(Queue1.dequeue());
            Queue2.dequeue();
        }
    }
    
    // trivial case - Queue1 is empty, Queue2 is not empty
    if (Queue1.isEmpty() && !Queue2.isEmpty()) {
        while (!Queue2.isEmpty()) {
            Queue3.enqueue(Queue2.dequeue());
        }
    }
    // trivial case - Queue2 is empty, Queue1 is not empty
    else if (Queue2.isEmpty() && !Queue1.isEmpty()) {
        while (!Queue1.isEmpty()) {
            Queue3.enqueue(Queue1.dequeue());
        }
    }
    
    while (!Queue3.isEmpty()) {
        int a = ((Integer)Queue3.peek()).intValue();
        System.out.println((Integer)(Queue3.dequeue()));
    }
    
    //int flag = 0;
    //while (!Queue3.isEmpty() && flag == 0) {
    //    int a = ((Integer)Queue3.peek()).intValue();
    //    if (a == 5) 
    //        flag = 1;
    //    else System.out.println((Integer)(Queue3.dequeue()));
    //}

/*
     QueueReferenceBased aQueue = new QueueReferenceBased();
     for (int i = 0; i < 9; i++) {
         aQueue.enqueue(new Integer(i));
     } // end for
     while (!aQueue.isEmpty()) {
         System.out.println((Integer)(aQueue.dequeue()));
     } // end while
*/
  }  // end main
}  // QueueTest